/************************************************************************/
// IC-Schnittstelle - 24AA025E48 Routine
// Programmierer: Fa. Schwabenplan, Ingo Schick
// Datum: 19.04.2020
/************************************************************************/

/************************************************************************/
// Include-Dateien
/************************************************************************/
#include "i2c2_master.h"
#include "24AA025E48.H"
#include "TCPIPLibrary/device_config.h"
#include <xc.h>
/************************************************************************/
	
/************************************************************************/
unsigned char Read_Byte_24AA025E48(unsigned char unc_Adresse, unsigned char unc_Register)
{
    unsigned char unc_Daten;
  
    unc_Adresse = 0b10100000 | (unc_Adresse << 1);

    IdleI2C2();						
    StartI2C2();
  	
    IdleI2C2();
    WriteI2C2(unc_Adresse);
    
    IdleI2C2();
  	WriteI2C2(unc_Register);
       
    StopI2C2();
    
    IdleI2C2();	
    RestartI2C2();
    
    IdleI2C2();
  	WriteI2C2(unc_Adresse + 1);
    
    IdleI2C2();
  	unc_Daten = ReadI2C2();

    StopI2C2();
   
    return unc_Daten; 
}  
/************************************************************************/
unsigned char Write_Byte_24AA025E48(unsigned char unc_Adresse, unsigned char unc_Register, unsigned char unc_Daten)
{
    unc_Adresse = 0b10100000 | (unc_Adresse << 1);

    IdleI2C2();						
    StartI2C2();
  	
    IdleI2C2();
  	WriteI2C2(unc_Adresse);
    
    IdleI2C2();
  	WriteI2C2(unc_Register);
    
    IdleI2C2();
  	WriteI2C2(unc_Daten);
    
    StopI2C2();
    __delay_ms(5);
    
    return unc_Daten; 
}
/************************************************************************/

