/************************************************************************/
//	Header-Datei fr 4x40 LC-Display
//	erstellt von Ingo Schick
//	Datum: 28.01.2010
/************************************************************************/

#ifndef __DISPLAY_H
#define __DISPLAY_H

#define _XTAL_FREQ 25000000
#include <xc.h>
#include <stdarg.h>
#include <stddef.h>
#include <stdio.h>


typedef unsigned char UBYTE;
typedef signed char BYTE;

#define TRIS_E TRISE
#define PORT_E PORTE
//#endif

#define LCD_DATA PORTE
#define LCD_DATA_TRIS TRIS_E
#define LCD_CTRL PORTEbits
#define LCD_CTRL_TRIS TRIS_E

#define DB7 (7)   // LCD DATA LINE7
#define DB6 (6)   // LCD DATA LINE6
#define DB5 (5)   // LCD DATA LINE5
#define DB4 (4)   // LCD DATA LINE4
#define DB3 (3)   // LCD DATA LINE3
#define DB2 (2)   // LCD DATA LINE2
#define DB1 (1)   // LCD DATA LINE1
#define DB0 (0)   // LCD DATA LINE0

#define LCD_E1 RE2
#define LCD_E  RE2
#define LCD_RW RE1
#define LCD_RS RE0
#define LCD_E2 RE3
#define BUSY_BIT RE7

#define UPPER DB2
#define LOWER DB3

#define DISPLAY_ON     (1<<DB2)
#define CURSOR_VISIBLE (1<<DB1)
#define CURSOR_FLASH   1
#define ALL_OFF        0


#define INVALID 0xff 
#define UNCHANGED 0xfe


#define NUM_OF_LINES 4
#define LINELENGTH 40



// Datentypen
typedef unsigned int UBYTE;
typedef unsigned long WORD;
typedef char UCHAR;
typedef short BIT;
typedef unsigned long ULONG;



void LcdInit(void);
void LcdClear(void);
void LcdClearLine(UBYTE Line);
void LcdPutCharacter(int Line, int Position, char Value);
int LcdPutCharacterHere(char Value);
void LcdSetCursorPosition(int Line, int Position, int CursorMode);
void LcdSetMode(int mode);
void LcdPrintf(int Line, int Position, char *fmt);
int LcdGetCurrentLine(void);
int LcdGetCurrentPosition(void);

#endif
