/************************************************************************/
// IC-Schnittstelle - LM75 Routine
// Programmierer: Fa. Schwabenplan, Ingo Schick
// Datum: 08.02.2020
/************************************************************************/

/************************************************************************/
// Include-Dateien
/************************************************************************/
#include "i2c2_master.h"
#include "LM75.H"
#include <xc.h>
/************************************************************************/
	
/************************************************************************/
unsigned int GetTempLM75 (unsigned char unc_Adresse)
{
  int int_LM75_Temp;
  unsigned int uint_msb, uint_lsb;

  unc_Adresse = 0b10010000 | (unc_Adresse << 1) + 1;	//Leseandresse bilden
  
    IdleI2C2();						//wait until I2C2 module is idle.
    StartI2C2();
  	
    IdleI2C2();
  	WriteI2C2(unc_Adresse);
    						//wait until I2C2 module is idle.
  	IdleI2C2();
  	uint_msb = ReadI2C2();
    AckI2C2();
  	
    IdleI2C2();
  	uint_lsb = ReadI2C2();
  	
    StopI2C2();
    
    int_LM75_Temp = uint_msb << 8 | uint_lsb; 	// Word aus Temp. Reg. bilden.
    int_LM75_Temp = int_LM75_Temp >> 7;		// ausgeblendete Bits ausblenden
      	

	//int_LM75_Temp = 0x192;

    if (int_LM75_Temp < 0x100) // Positiver Wert?
	{ 
    	return int_LM75_Temp / 2; // positiver Wert
  	}  
  	else 
	{
    	return (int_LM75_Temp / 2) -256; // negativer Wert
  	}    	
  	
}  
/************************************************************************/

