/************************************************************************/
// Systeminformationen und Konfig-Bits fr PIC18F9J60
// Programmierer: Fa. Schwabenplan, Ingo Schick
// Datum: 29.02.2020
/************************************************************************/

// Configuration bits: selected in the GUI

// CONFIG1L
#pragma config WDT = OFF    // Watchdog Timer Enable bit->WDT disabled (control is placed on SWDTEN bit)
#pragma config STVR = OFF    // Stack Overflow/Underflow Reset Enable bit->Reset on stack overflow/underflow disabled
#pragma config XINST = OFF    // Extended Instruction Set Enable bit->Instruction set extension and Indexed Addressing mode disabled (Legacy mode)
#pragma config DEBUG = OFF    // Background Debugger Enable bit->Background debugger disabled; RB6 and RB7 configured as general purpose I/O pins

// CONFIG1H
#pragma config CP0 = OFF    // Code Protection bit->Program memory is not code-protected

// CONFIG2L
#pragma config FOSC = HS    // Oscillator Selection bits->HS oscillator
#pragma config FOSC2 = OFF    // Default/Reset System Clock Select bit->Clock selected by FOSC1:FOSC0 as system clock is enabled when OSCCON<1:0> = 00
#pragma config FCMEN = OFF    // Fail-Safe Clock Monitor Enable->Fail-Safe Clock Monitor disabled
#pragma config IESO = ON    // Two-Speed Start-up (Internal/External Oscillator Switchover) Control bit->Two-Speed Start-up enabled

// CONFIG2H
#pragma config WDTPS = 32768    // Watchdog Timer Postscaler Select bits->1:32768

// CONFIG3L
#pragma config EASHFT = ON    // External Address Bus Shift Enable bit->Address shifting enabled; address on external bus is offset to start at 000000h
#pragma config MODE = MM    // External Memory Bus->Microcontroller mode, external bus disabled
#pragma config BW = 16    // Data Bus Width Select bit->16-Bit Data Width mode
#pragma config WAIT = OFF    // External Bus Wait Enable bit->Wait states for operations on external memory bus disabled

// CONFIG3H
#pragma config CCP2MX = OFF    // ECCP2 MUX bit->ECCP2/P2A is multiplexed with RE7 in Microcontroller mode (80-pin and 100-pin devices) or with RB3 in Extended Microcontroller mode (100-pin devices only)
#pragma config ECCPMX = ON    // ECCP MUX bit->ECCP1 outputs (P1B/P1C) are multiplexed with RE6 and RE5; ECCP3 outputs (P3B/P3C) are multiplexed with RE4 and RE3
#pragma config ETHLED = ON    // Ethernet LED Enable bit->RA0/RA1 function as I/O regardless of Ethernet module status
