/************************************************************************/
// Systeminformationen und Konfig-Bits fr PIC18F9J60
// Programmierer: Fa. Schwabenplan, Ingo Schick
// Datum: 29.02.2020
/************************************************************************/

#ifndef DEVICE_CONFIG_H
#define	DEVICE_CONFIG_H

#define _XTAL_FREQ 25000000
#define MC_TYPE "PIC18F97J60"                           // Microcontroller-Typ
#define HARDWARE_VERSION "1.2"                          // Hardware Version
#define OSC " MHz - HC49"                               // Taktfrequenz
#define SOFTWARE_VERSION  "1.0"                         // Software Version
#define HEXFILE "TCPIP.HEX"                             // Hex-File
#define B_DATE "28.02.2020"                             // Erstelldatum
#define BOOTLOADER_MODE "Off"                           // Bootloader lesen
#define DEBUG_MODE "Off"                                // Debug-Mode lesen
#define PROT_VERSION "3.0"                              // Protokoll Version
#define INTERFACE " KHz - I2C-Bus"                      // Interface on Board
#define RTC_TYP "LM1337"                                // RTC-Typ
#define Temp_Sensor_TYP "LM75"                          // Temp_Sensor

// Variablen zum Auslesen aus dem Speicherbaustein
unsigned char chr_MAC[6];
    
unsigned char chr_IP[4];
unsigned char chr_SN[4];
unsigned char chr_ROU[4];
unsigned char chr_GW[4];
unsigned char chr_DNS[4];
    
unsigned char chr_Port[1];
unsigned char chr_USART;
  
// Variablen fr die Applikation
unsigned long ulg_Baud = 0; //115200;                     // Baudrate
unsigned short int usi_I2C_Speed = 0; //400;             // I2C-Geschwindigkeit
unsigned short int usi_Temp_Sensor_Adr = 1;             // Adresse Temp. Sensor

unsigned short int usi_OSC = _XTAL_FREQ / 1000000;

unsigned long ipv4_IP = 0; //0xc0a86410;                     // 192.168.100.16
unsigned long ipv4_subnetMask =  0; //0xffffff00;             // 255.255.255.0
unsigned long ipv4_router =  0; //0xc0a86401;                 // 192.168.100.1
unsigned long ipv4_gateway =  0; //0xc0a86401;                // 192.168.100.1
unsigned long ipv4_dns = 0; // 0xc0a86401;                    // 192.168.100.1


unsigned long Server_IP_a =  0; // 192;                        // IP-Adresse des Server
unsigned long Server_IP_b = 0; // 168;
unsigned long Server_IP_c = 0; // 100;
unsigned long Server_IP_d = 0; // 101;

unsigned short int usi_Port = 0; //60;                            // Port des Servers


//#define MAC_ADDRESS {0x00,0x04,0xa3,0x00,0x16,0x06}     // MAC-Adresse

#define MAC_ADDRESS {chr_MAC[0],chr_MAC[1],chr_MAC[2],chr_MAC[3],chr_MAC[4],chr_MAC[5]}

#endif	/* DEVICE_CONFIG_H */
/************************************************************************/