/************************************************************************/
// IP-Database PIC18F97J60
// Programmierer: Fa. Schwabenplan, Ingo Schick
// Datum: 29.02.2020
/************************************************************************/

/************************************************************************/
// Include-Dateien
/************************************************************************/
#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "ip_database.h"

#include "device_config.h"


ip_db_info_t ip_database_info;

void ipdb_init(void)
{
    // Verweis auf device_config.h
    ip_database_info.ipv4_myAddress = ipv4_IP;              //192.168.100.16
    ip_database_info.ipv4_subnetMask = ipv4_subnetMask;     //255.255.255.0
    ip_database_info.ipv4_router = ipv4_router;             //192.168.100.1
    ip_database_info.ipv4_dns[0] = 0xc0a86401;              //192.168.100.1
    ip_database_info.ipv4_dns[1] = 0;
    for(uint8_t x=0; x < MAX_NTP; x++)
        ip_database_info.ipv4_ntpAddress[x] = 0;
    ip_database_info.ipv4_tftpAddress = 0;
    
    //ip_database_info.ipv4_myAddress = 0xc0a86410;       //192.168.100.16
    //ip_database_info.ipv4_subnetMask = 0xffffff00;
    //ip_database_info.ipv4_router = 0xc0a86401;
    //ip_database_info.ipv4_dns[0] = 0xc0a86401;
    //ip_database_info.ipv4_dns[1] = 0;
}

uint32_t makeStrToIpv4Address(char *str)
{
    uint32_t ip_addr;
    char *pch;    
    uint8_t x =3;
    pch = strtok(str,".");
    while((pch != NULL))
    {        
       ((uint8_t *)&ip_addr)[x]= (uint16_t)atoi((const char*)pch); //jira: CAE_MCU8-5647
        x--;     
        pch = strtok (NULL,".");
    }
    return ip_addr;
}

char *makeIpv4AddresstoStr(uint32_t addr)
{
    static char ip_str[15];
    
    sprintf(ip_str,"%d.%d.%d.%d",((char*)&addr)[3],((char*)&addr)[2],((char*)&addr)[1],((char*)&addr)[0]);    
    
    return ip_str;
}

void uint32IP_to_String(uint32_t uint32IP, char str_IP[]) 
{
  uint8_t bytes[4];
  bytes[0] = uint32IP & 0xFF;
  bytes[1] = (uint32IP >> 8) & 0xFF;
  bytes[2] = (uint32IP >> 16) & 0xFF;
  bytes[3] = (uint32IP >> 24) & 0xFF;

  sprintf(str_IP, "%d.%d.%d.%d", bytes[3], bytes[2], bytes[1], bytes[0]);
}

void char_IP_to_uint32IP(char chr_IP[], uint32_t uint32IP)
{
    // UINT32 Ansicht
    uint32IP =  (uint32_t) chr_IP[0]<<24 | (uint32_t) chr_IP[1]<<16 | (uint32_t) chr_IP[2]<<8 | (uint32_t) chr_IP[3];
}

