/************************************************************************/
// MAC-Adresse fr PIC18F9J60
// Programmierer: Fa. Schwabenplan, Ingo Schick
// Datum: 29.02.2020
/************************************************************************/

#ifndef MAC_ADDRESS_H
#define	MAC_ADDRESS_H

#include <stdint.h>

/******************************** MAC Address *********************************/

//#define MAC_ADDRESS {0x00,0x04,0xa3,0x00,0x17,0x06}

typedef union
{
    uint8_t mac_array[6];
    struct { uint8_t byte1,byte2,byte3,byte4,byte5,byte6; } s;
} mac48Address_t;

typedef union
{
    uint8_t mac_array[8];
    struct { uint8_t byte1,byte2,byte3,byte4,byte5,byte6,byte7,byte8; } s;
} mac64Address_t;

extern const mac48Address_t broadcastMAC;
extern mac48Address_t hostMacAddress;

const mac48Address_t *MAC_getAddress(void);

void MAC_to_String(char str_MAC[]);

#endif	/* MAC_ADDRESS_H */

