/************************************************************************/
// ADW_PIC18F97K60.C fr PIC18F97J60
// Programmierer: Fa. Schwabenplan, Ingo Schick
// Compiler: XC8
// Datum: 25.08.2018
/************************************************************************/

#ifndef ADC_H
#define ADC_H

#include <xc.h>
#include <stdint.h>
#include <stdbool.h>

typedef uint16_t adc_result_t;
typedef struct
{
    adc_result_t adcResult1;
    adc_result_t adcResult2;
} adc_sync_double_result_t;


typedef enum
{
    channel_AN8 =  0x8,
    channel_AN9 =  0x9,
    channel_AN10 =  0xA,
    channel_AN11 =  0xB,
    channel_AN12 =  0xC,
    channel_AN13 =  0xD,
    channel_AN14 =  0xE,
    channel_AN15 =  0xF
} adc_channel_t;


void ADC_Initialize(void);
void ADC_SelectChannel(adc_channel_t channel);
void ADC_StartConversion();
bool ADC_IsConversionDone();
adc_result_t ADC_GetConversionResult(void);
adc_result_t ADC_GetConversion(adc_channel_t channel);
void ADC_TemperatureAcquisitionDelay(void);

#endif	//ADC_H
