/************************************************************************/
// USART.C fr PIC18F97J60
// Programmierer: Fa. Schwabenplan, Ingo Schick
// Compiler: XC8
// Datum: 08.02.2020
/************************************************************************/

#include "eusart1.h"
#include <xc.h>

/************************************************************************/
void Init_USART(unsigned long ulg_Baud)
{
    BAUDCON1 = 0x08;
    RCSTA1 = 0x90;
    TXSTA1 = 0x24;

    
    	switch (ulg_Baud)   {
			case 9600:      // Baud Rate = 9600;
                            SPBRG1 = 0x8A;
                            SPBRGH1 = 0x02;
							break;

			case 19200:		// Baud Rate = 19200;
                            SPBRG1 = 0x45;
                            SPBRGH1 = 0x01;
							break;							

			case 57600:     // Baud Rate = 57600;
                            SPBRG1 = 0x6C;
                            SPBRGH1 = 0x00;
							break;

			case 115200:    // Baud Rate = 115200;     
                            SPBRG1 = 0x35;
                            SPBRGH1 = 0x00;
							break;
                            }

}
/************************************************************************/

/************************************************************************/
void USART_Write_String(char *text)
{
  int i;
  for(i=0;text[i]!='\0';i++)
    USART_Write(text[i]);
}
/************************************************************************/

/************************************************************************/
void USART_Write(uint8_t txData)
{
    while(0 == PIR1bits.TX1IF)
    {
    }

    TXREG1 = txData;    // Write the data byte to the USART.
}
/************************************************************************/

/************************************************************************/
void USART_Read_String(char *Output, unsigned int length)
{
  unsigned int i;
  for(int i=0;i<length;i++)
  Output[i] = USART_Read();
}
/************************************************************************/

/************************************************************************/
uint8_t USART_Read(void)
{

    while(!PIR1bits.RC1IF)
    {
    }

    if(1 == RCSTA1bits.OERR)
    {
        // EUSART1 error - restart

        RCSTA1bits.CREN = 0; 
        RCSTA1bits.CREN = 1; 
    }

    return RCREG1;
}
/************************************************************************/

/************************************************************************/
char getch(void)
{
    return USART_Read();
}
/************************************************************************/

/************************************************************************/
void putch(char txData)
{
    USART_Write(txData);
}
/************************************************************************/
