/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description:
    This header file provides implementations for pin APIs for all pins selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.79.0
        Device            :  PIC18F97J60
        Version           :  2.0
    The generated drivers are tested against the following:
        Compiler          :  XC8 2.10 and above
        MPLAB             :  MPLAB X 5.30

    Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

/**
  Section: Included Files
*/

#include <xc.h>

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set RA0 aliases
#define RA0_TRIS                 TRISAbits.TRISA0
#define RA0_LAT                  LATAbits.LATA0
#define RA0_PORT                 PORTAbits.RA0
#define RA0_ANS                  anselRA0bits.anselRA0
#define RA0_SetHigh()            do { LATAbits.LATA0 = 1; } while(0)
#define RA0_SetLow()             do { LATAbits.LATA0 = 0; } while(0)
#define RA0_Toggle()             do { LATAbits.LATA0 = ~LATAbits.LATA0; } while(0)
#define RA0_GetValue()           PORTAbits.RA0
#define RA0_SetDigitalInput()    do { TRISAbits.TRISA0 = 1; } while(0)
#define RA0_SetDigitalOutput()   do { TRISAbits.TRISA0 = 0; } while(0)
#define RA0_SetAnalogMode()      do { anselRA0bits.anselRA0 = 1; } while(0)
#define RA0_SetDigitalMode()     do { anselRA0bits.anselRA0 = 0; } while(0)

// get/set RA1 aliases
#define RA1_TRIS                 TRISAbits.TRISA1
#define RA1_LAT                  LATAbits.LATA1
#define RA1_PORT                 PORTAbits.RA1
#define RA1_ANS                  anselRA1bits.anselRA1
#define RA1_SetHigh()            do { LATAbits.LATA1 = 1; } while(0)
#define RA1_SetLow()             do { LATAbits.LATA1 = 0; } while(0)
#define RA1_Toggle()             do { LATAbits.LATA1 = ~LATAbits.LATA1; } while(0)
#define RA1_GetValue()           PORTAbits.RA1
#define RA1_SetDigitalInput()    do { TRISAbits.TRISA1 = 1; } while(0)
#define RA1_SetDigitalOutput()   do { TRISAbits.TRISA1 = 0; } while(0)
#define RA1_SetAnalogMode()      do { anselRA1bits.anselRA1 = 1; } while(0)
#define RA1_SetDigitalMode()     do { anselRA1bits.anselRA1 = 0; } while(0)

// get/set RA2 aliases
#define RA2_TRIS                 TRISAbits.TRISA2
#define RA2_LAT                  LATAbits.LATA2
#define RA2_PORT                 PORTAbits.RA2
#define RA2_ANS                  anselRA2bits.anselRA2
#define RA2_SetHigh()            do { LATAbits.LATA2 = 1; } while(0)
#define RA2_SetLow()             do { LATAbits.LATA2 = 0; } while(0)
#define RA2_Toggle()             do { LATAbits.LATA2 = ~LATAbits.LATA2; } while(0)
#define RA2_GetValue()           PORTAbits.RA2
#define RA2_SetDigitalInput()    do { TRISAbits.TRISA2 = 1; } while(0)
#define RA2_SetDigitalOutput()   do { TRISAbits.TRISA2 = 0; } while(0)
#define RA2_SetAnalogMode()      do { anselRA2bits.anselRA2 = 1; } while(0)
#define RA2_SetDigitalMode()     do { anselRA2bits.anselRA2 = 0; } while(0)

// get/set RA3 aliases
#define RA3_TRIS                 TRISAbits.TRISA3
#define RA3_LAT                  LATAbits.LATA3
#define RA3_PORT                 PORTAbits.RA3
#define RA3_ANS                  anselRA3bits.anselRA3
#define RA3_SetHigh()            do { LATAbits.LATA3 = 1; } while(0)
#define RA3_SetLow()             do { LATAbits.LATA3 = 0; } while(0)
#define RA3_Toggle()             do { LATAbits.LATA3 = ~LATAbits.LATA3; } while(0)
#define RA3_GetValue()           PORTAbits.RA3
#define RA3_SetDigitalInput()    do { TRISAbits.TRISA3 = 1; } while(0)
#define RA3_SetDigitalOutput()   do { TRISAbits.TRISA3 = 0; } while(0)
#define RA3_SetAnalogMode()      do { anselRA3bits.anselRA3 = 1; } while(0)
#define RA3_SetDigitalMode()     do { anselRA3bits.anselRA3 = 0; } while(0)

// get/set RA4 aliases
#define RA4_TRIS                 TRISAbits.TRISA4
#define RA4_LAT                  LATAbits.LATA4
#define RA4_PORT                 PORTAbits.RA4
#define RA4_SetHigh()            do { LATAbits.LATA4 = 1; } while(0)
#define RA4_SetLow()             do { LATAbits.LATA4 = 0; } while(0)
#define RA4_Toggle()             do { LATAbits.LATA4 = ~LATAbits.LATA4; } while(0)
#define RA4_GetValue()           PORTAbits.RA4
#define RA4_SetDigitalInput()    do { TRISAbits.TRISA4 = 1; } while(0)
#define RA4_SetDigitalOutput()   do { TRISAbits.TRISA4 = 0; } while(0)

// get/set RA5 aliases
#define RA5_TRIS                 TRISAbits.TRISA5
#define RA5_LAT                  LATAbits.LATA5
#define RA5_PORT                 PORTAbits.RA5
#define RA5_ANS                  anselRA5bits.anselRA5
#define RA5_SetHigh()            do { LATAbits.LATA5 = 1; } while(0)
#define RA5_SetLow()             do { LATAbits.LATA5 = 0; } while(0)
#define RA5_Toggle()             do { LATAbits.LATA5 = ~LATAbits.LATA5; } while(0)
#define RA5_GetValue()           PORTAbits.RA5
#define RA5_SetDigitalInput()    do { TRISAbits.TRISA5 = 1; } while(0)
#define RA5_SetDigitalOutput()   do { TRISAbits.TRISA5 = 0; } while(0)
#define RA5_SetAnalogMode()      do { anselRA5bits.anselRA5 = 1; } while(0)
#define RA5_SetDigitalMode()     do { anselRA5bits.anselRA5 = 0; } while(0)

// get/set RB0 aliases
#define RB0_TRIS                 TRISBbits.TRISB0
#define RB0_LAT                  LATBbits.LATB0
#define RB0_PORT                 PORTBbits.RB0
#define RB0_SetHigh()            do { LATBbits.LATB0 = 1; } while(0)
#define RB0_SetLow()             do { LATBbits.LATB0 = 0; } while(0)
#define RB0_Toggle()             do { LATBbits.LATB0 = ~LATBbits.LATB0; } while(0)
#define RB0_GetValue()           PORTBbits.RB0
#define RB0_SetDigitalInput()    do { TRISBbits.TRISB0 = 1; } while(0)
#define RB0_SetDigitalOutput()   do { TRISBbits.TRISB0 = 0; } while(0)

// get/set RB1 aliases
#define RB1_TRIS                 TRISBbits.TRISB1
#define RB1_LAT                  LATBbits.LATB1
#define RB1_PORT                 PORTBbits.RB1
#define RB1_SetHigh()            do { LATBbits.LATB1 = 1; } while(0)
#define RB1_SetLow()             do { LATBbits.LATB1 = 0; } while(0)
#define RB1_Toggle()             do { LATBbits.LATB1 = ~LATBbits.LATB1; } while(0)
#define RB1_GetValue()           PORTBbits.RB1
#define RB1_SetDigitalInput()    do { TRISBbits.TRISB1 = 1; } while(0)
#define RB1_SetDigitalOutput()   do { TRISBbits.TRISB1 = 0; } while(0)

// get/set RB2 aliases
#define RB2_TRIS                 TRISBbits.TRISB2
#define RB2_LAT                  LATBbits.LATB2
#define RB2_PORT                 PORTBbits.RB2
#define RB2_SetHigh()            do { LATBbits.LATB2 = 1; } while(0)
#define RB2_SetLow()             do { LATBbits.LATB2 = 0; } while(0)
#define RB2_Toggle()             do { LATBbits.LATB2 = ~LATBbits.LATB2; } while(0)
#define RB2_GetValue()           PORTBbits.RB2
#define RB2_SetDigitalInput()    do { TRISBbits.TRISB2 = 1; } while(0)
#define RB2_SetDigitalOutput()   do { TRISBbits.TRISB2 = 0; } while(0)

// get/set RB3 aliases
#define RB3_TRIS                 TRISBbits.TRISB3
#define RB3_LAT                  LATBbits.LATB3
#define RB3_PORT                 PORTBbits.RB3
#define RB3_SetHigh()            do { LATBbits.LATB3 = 1; } while(0)
#define RB3_SetLow()             do { LATBbits.LATB3 = 0; } while(0)
#define RB3_Toggle()             do { LATBbits.LATB3 = ~LATBbits.LATB3; } while(0)
#define RB3_GetValue()           PORTBbits.RB3
#define RB3_SetDigitalInput()    do { TRISBbits.TRISB3 = 1; } while(0)
#define RB3_SetDigitalOutput()   do { TRISBbits.TRISB3 = 0; } while(0)

// get/set RB4 aliases
#define RB4_TRIS                 TRISBbits.TRISB4
#define RB4_LAT                  LATBbits.LATB4
#define RB4_PORT                 PORTBbits.RB4
#define RB4_SetHigh()            do { LATBbits.LATB4 = 1; } while(0)
#define RB4_SetLow()             do { LATBbits.LATB4 = 0; } while(0)
#define RB4_Toggle()             do { LATBbits.LATB4 = ~LATBbits.LATB4; } while(0)
#define RB4_GetValue()           PORTBbits.RB4
#define RB4_SetDigitalInput()    do { TRISBbits.TRISB4 = 1; } while(0)
#define RB4_SetDigitalOutput()   do { TRISBbits.TRISB4 = 0; } while(0)

// get/set RB5 aliases
#define RB5_TRIS                 TRISBbits.TRISB5
#define RB5_LAT                  LATBbits.LATB5
#define RB5_PORT                 PORTBbits.RB5
#define RB5_SetHigh()            do { LATBbits.LATB5 = 1; } while(0)
#define RB5_SetLow()             do { LATBbits.LATB5 = 0; } while(0)
#define RB5_Toggle()             do { LATBbits.LATB5 = ~LATBbits.LATB5; } while(0)
#define RB5_GetValue()           PORTBbits.RB5
#define RB5_SetDigitalInput()    do { TRISBbits.TRISB5 = 1; } while(0)
#define RB5_SetDigitalOutput()   do { TRISBbits.TRISB5 = 0; } while(0)

// get/set RB6 aliases
#define RB6_TRIS                 TRISBbits.TRISB6
#define RB6_LAT                  LATBbits.LATB6
#define RB6_PORT                 PORTBbits.RB6
#define RB6_SetHigh()            do { LATBbits.LATB6 = 1; } while(0)
#define RB6_SetLow()             do { LATBbits.LATB6 = 0; } while(0)
#define RB6_Toggle()             do { LATBbits.LATB6 = ~LATBbits.LATB6; } while(0)
#define RB6_GetValue()           PORTBbits.RB6
#define RB6_SetDigitalInput()    do { TRISBbits.TRISB6 = 1; } while(0)
#define RB6_SetDigitalOutput()   do { TRISBbits.TRISB6 = 0; } while(0)

// get/set RB7 aliases
#define RB7_TRIS                 TRISBbits.TRISB7
#define RB7_LAT                  LATBbits.LATB7
#define RB7_PORT                 PORTBbits.RB7
#define RB7_SetHigh()            do { LATBbits.LATB7 = 1; } while(0)
#define RB7_SetLow()             do { LATBbits.LATB7 = 0; } while(0)
#define RB7_Toggle()             do { LATBbits.LATB7 = ~LATBbits.LATB7; } while(0)
#define RB7_GetValue()           PORTBbits.RB7
#define RB7_SetDigitalInput()    do { TRISBbits.TRISB7 = 1; } while(0)
#define RB7_SetDigitalOutput()   do { TRISBbits.TRISB7 = 0; } while(0)

// get/set RC0 procedures
#define RC0_SetHigh()               do { LATCbits.LATC0 = 1; } while(0)
#define RC0_SetLow()                do { LATCbits.LATC0 = 0; } while(0)
#define RC0_Toggle()                do { LATCbits.LATC0 = ~LATCbits.LATC0; } while(0)
#define RC0_GetValue()              PORTCbits.RC0
#define RC0_SetDigitalInput()       do { TRISCbits.TRISC0 = 1; } while(0)
#define RC0_SetDigitalOutput()      do { TRISCbits.TRISC0 = 0; } while(0)

// get/set RC2 aliases
#define RC2_TRIS                 TRISCbits.TRISC2
#define RC2_LAT                  LATCbits.LATC2
#define RC2_PORT                 PORTCbits.RC2
#define RC2_SetHigh()            do { LATCbits.LATC2 = 1; } while(0)
#define RC2_SetLow()             do { LATCbits.LATC2 = 0; } while(0)
#define RC2_Toggle()             do { LATCbits.LATC2 = ~LATCbits.LATC2; } while(0)
#define RC2_GetValue()           PORTCbits.RC2
#define RC2_SetDigitalInput()    do { TRISCbits.TRISC2 = 1; } while(0)
#define RC2_SetDigitalOutput()   do { TRISCbits.TRISC2 = 0; } while(0)

// get/set RC3 procedures
#define RC3_SetHigh()               do { LATCbits.LATC3 = 1; } while(0)
#define RC3_SetLow()                do { LATCbits.LATC3 = 0; } while(0)
#define RC3_Toggle()                do { LATCbits.LATC3 = ~LATCbits.LATC3; } while(0)
#define RC3_GetValue()              PORTCbits.RC3
#define RC3_SetDigitalInput()       do { TRISCbits.TRISC3 = 1; } while(0)
#define RC3_SetDigitalOutput()      do { TRISCbits.TRISC3 = 0; } while(0)

// get/set RC5 procedures
#define RC5_SetHigh()               do { LATCbits.LATC5 = 1; } while(0)
#define RC5_SetLow()                do { LATCbits.LATC5 = 0; } while(0)
#define RC5_Toggle()                do { LATCbits.LATC5 = ~LATCbits.LATC5; } while(0)
#define RC5_GetValue()              PORTCbits.RC5
#define RC5_SetDigitalInput()       do { TRISCbits.TRISC5 = 1; } while(0)
#define RC5_SetDigitalOutput()      do { TRISCbits.TRISC5 = 0; } while(0)

// get/set RC6 procedures
#define RC6_SetHigh()               do { LATCbits.LATC6 = 1; } while(0)
#define RC6_SetLow()                do { LATCbits.LATC6 = 0; } while(0)
#define RC6_Toggle()                do { LATCbits.LATC6 = ~LATCbits.LATC6; } while(0)
#define RC6_GetValue()              PORTCbits.RC6
#define RC6_SetDigitalInput()       do { TRISCbits.TRISC6 = 1; } while(0)
#define RC6_SetDigitalOutput()      do { TRISCbits.TRISC6 = 0; } while(0)

// get/set RD0 aliases
#define RD0_TRIS                 TRISDbits.TRISD0
#define RD0_LAT                  LATDbits.LATD0
#define RD0_PORT                 PORTDbits.RD0
#define RD0_SetHigh()            do { LATDbits.LATD0 = 1; } while(0)
#define RD0_SetLow()             do { LATDbits.LATD0 = 0; } while(0)
#define RD0_Toggle()             do { LATDbits.LATD0 = ~LATDbits.LATD0; } while(0)
#define RD0_GetValue()           PORTDbits.RD0
#define RD0_SetDigitalInput()    do { TRISDbits.TRISD0 = 1; } while(0)
#define RD0_SetDigitalOutput()   do { TRISDbits.TRISD0 = 0; } while(0)

// get/set RD1 aliases
#define RD1_TRIS                 TRISDbits.TRISD1
#define RD1_LAT                  LATDbits.LATD1
#define RD1_PORT                 PORTDbits.RD1
#define RD1_SetHigh()            do { LATDbits.LATD1 = 1; } while(0)
#define RD1_SetLow()             do { LATDbits.LATD1 = 0; } while(0)
#define RD1_Toggle()             do { LATDbits.LATD1 = ~LATDbits.LATD1; } while(0)
#define RD1_GetValue()           PORTDbits.RD1
#define RD1_SetDigitalInput()    do { TRISDbits.TRISD1 = 1; } while(0)
#define RD1_SetDigitalOutput()   do { TRISDbits.TRISD1 = 0; } while(0)

// get/set RD2 aliases
#define RD2_TRIS                 TRISDbits.TRISD2
#define RD2_LAT                  LATDbits.LATD2
#define RD2_PORT                 PORTDbits.RD2
#define RD2_SetHigh()            do { LATDbits.LATD2 = 1; } while(0)
#define RD2_SetLow()             do { LATDbits.LATD2 = 0; } while(0)
#define RD2_Toggle()             do { LATDbits.LATD2 = ~LATDbits.LATD2; } while(0)
#define RD2_GetValue()           PORTDbits.RD2
#define RD2_SetDigitalInput()    do { TRISDbits.TRISD2 = 1; } while(0)
#define RD2_SetDigitalOutput()   do { TRISDbits.TRISD2 = 0; } while(0)

// get/set RD3 aliases
#define RD3_TRIS                 TRISDbits.TRISD3
#define RD3_LAT                  LATDbits.LATD3
#define RD3_PORT                 PORTDbits.RD3
#define RD3_SetHigh()            do { LATDbits.LATD3 = 1; } while(0)
#define RD3_SetLow()             do { LATDbits.LATD3 = 0; } while(0)
#define RD3_Toggle()             do { LATDbits.LATD3 = ~LATDbits.LATD3; } while(0)
#define RD3_GetValue()           PORTDbits.RD3
#define RD3_SetDigitalInput()    do { TRISDbits.TRISD3 = 1; } while(0)
#define RD3_SetDigitalOutput()   do { TRISDbits.TRISD3 = 0; } while(0)

// get/set RD4 aliases
#define RD4_TRIS                 TRISDbits.TRISD4
#define RD4_LAT                  LATDbits.LATD4
#define RD4_PORT                 PORTDbits.RD4
#define RD4_SetHigh()            do { LATDbits.LATD4 = 1; } while(0)
#define RD4_SetLow()             do { LATDbits.LATD4 = 0; } while(0)
#define RD4_Toggle()             do { LATDbits.LATD4 = ~LATDbits.LATD4; } while(0)
#define RD4_GetValue()           PORTDbits.RD4
#define RD4_SetDigitalInput()    do { TRISDbits.TRISD4 = 1; } while(0)
#define RD4_SetDigitalOutput()   do { TRISDbits.TRISD4 = 0; } while(0)

// get/set RD7 aliases
#define RD7_TRIS                 TRISDbits.TRISD7
#define RD7_LAT                  LATDbits.LATD7
#define RD7_PORT                 PORTDbits.RD7
#define RD7_SetHigh()            do { LATDbits.LATD7 = 1; } while(0)
#define RD7_SetLow()             do { LATDbits.LATD7 = 0; } while(0)
#define RD7_Toggle()             do { LATDbits.LATD7 = ~LATDbits.LATD7; } while(0)
#define RD7_GetValue()           PORTDbits.RD7
#define RD7_SetDigitalInput()    do { TRISDbits.TRISD7 = 1; } while(0)
#define RD7_SetDigitalOutput()   do { TRISDbits.TRISD7 = 0; } while(0)

// get/set RE0 aliases
#define RE0_TRIS                 TRISEbits.TRISE0
#define RE0_LAT                  LATEbits.LATE0
#define RE0_PORT                 PORTEbits.RE0
#define RE0_SetHigh()            do { LATEbits.LATE0 = 1; } while(0)
#define RE0_SetLow()             do { LATEbits.LATE0 = 0; } while(0)
#define RE0_Toggle()             do { LATEbits.LATE0 = ~LATEbits.LATE0; } while(0)
#define RE0_GetValue()           PORTEbits.RE0
#define RE0_SetDigitalInput()    do { TRISEbits.TRISE0 = 1; } while(0)
#define RE0_SetDigitalOutput()   do { TRISEbits.TRISE0 = 0; } while(0)

// get/set RE1 aliases
#define RE1_TRIS                 TRISEbits.TRISE1
#define RE1_LAT                  LATEbits.LATE1
#define RE1_PORT                 PORTEbits.RE1
#define RE1_SetHigh()            do { LATEbits.LATE1 = 1; } while(0)
#define RE1_SetLow()             do { LATEbits.LATE1 = 0; } while(0)
#define RE1_Toggle()             do { LATEbits.LATE1 = ~LATEbits.LATE1; } while(0)
#define RE1_GetValue()           PORTEbits.RE1
#define RE1_SetDigitalInput()    do { TRISEbits.TRISE1 = 1; } while(0)
#define RE1_SetDigitalOutput()   do { TRISEbits.TRISE1 = 0; } while(0)

// get/set RE2 aliases
#define RE2_TRIS                 TRISEbits.TRISE2
#define RE2_LAT                  LATEbits.LATE2
#define RE2_PORT                 PORTEbits.RE2
#define RE2_SetHigh()            do { LATEbits.LATE2 = 1; } while(0)
#define RE2_SetLow()             do { LATEbits.LATE2 = 0; } while(0)
#define RE2_Toggle()             do { LATEbits.LATE2 = ~LATEbits.LATE2; } while(0)
#define RE2_GetValue()           PORTEbits.RE2
#define RE2_SetDigitalInput()    do { TRISEbits.TRISE2 = 1; } while(0)
#define RE2_SetDigitalOutput()   do { TRISEbits.TRISE2 = 0; } while(0)

// get/set RE3 aliases
#define RE3_TRIS                 TRISEbits.TRISE3
#define RE3_LAT                  LATEbits.LATE3
#define RE3_PORT                 PORTEbits.RE3
#define RE3_SetHigh()            do { LATEbits.LATE3 = 1; } while(0)
#define RE3_SetLow()             do { LATEbits.LATE3 = 0; } while(0)
#define RE3_Toggle()             do { LATEbits.LATE3 = ~LATEbits.LATE3; } while(0)
#define RE3_GetValue()           PORTEbits.RE3
#define RE3_SetDigitalInput()    do { TRISEbits.TRISE3 = 1; } while(0)
#define RE3_SetDigitalOutput()   do { TRISEbits.TRISE3 = 0; } while(0)

// get/set RE4 aliases
#define RE4_TRIS                 TRISEbits.TRISE4
#define RE4_LAT                  LATEbits.LATE4
#define RE4_PORT                 PORTEbits.RE4
#define RE4_SetHigh()            do { LATEbits.LATE4 = 1; } while(0)
#define RE4_SetLow()             do { LATEbits.LATE4 = 0; } while(0)
#define RE4_Toggle()             do { LATEbits.LATE4 = ~LATEbits.LATE4; } while(0)
#define RE4_GetValue()           PORTEbits.RE4
#define RE4_SetDigitalInput()    do { TRISEbits.TRISE4 = 1; } while(0)
#define RE4_SetDigitalOutput()   do { TRISEbits.TRISE4 = 0; } while(0)

// get/set RE5 aliases
#define RE5_TRIS                 TRISEbits.TRISE5
#define RE5_LAT                  LATEbits.LATE5
#define RE5_PORT                 PORTEbits.RE5
#define RE5_SetHigh()            do { LATEbits.LATE5 = 1; } while(0)
#define RE5_SetLow()             do { LATEbits.LATE5 = 0; } while(0)
#define RE5_Toggle()             do { LATEbits.LATE5 = ~LATEbits.LATE5; } while(0)
#define RE5_GetValue()           PORTEbits.RE5
#define RE5_SetDigitalInput()    do { TRISEbits.TRISE5 = 1; } while(0)
#define RE5_SetDigitalOutput()   do { TRISEbits.TRISE5 = 0; } while(0)

// get/set RE6 aliases
#define RE6_TRIS                 TRISEbits.TRISE6
#define RE6_LAT                  LATEbits.LATE6
#define RE6_PORT                 PORTEbits.RE6
#define RE6_SetHigh()            do { LATEbits.LATE6 = 1; } while(0)
#define RE6_SetLow()             do { LATEbits.LATE6 = 0; } while(0)
#define RE6_Toggle()             do { LATEbits.LATE6 = ~LATEbits.LATE6; } while(0)
#define RE6_GetValue()           PORTEbits.RE6
#define RE6_SetDigitalInput()    do { TRISEbits.TRISE6 = 1; } while(0)
#define RE6_SetDigitalOutput()   do { TRISEbits.TRISE6 = 0; } while(0)

// get/set RE7 aliases
#define RE7_TRIS                 TRISEbits.TRISE7
#define RE7_LAT                  LATEbits.LATE7
#define RE7_PORT                 PORTEbits.RE7
#define RE7_SetHigh()            do { LATEbits.LATE7 = 1; } while(0)
#define RE7_SetLow()             do { LATEbits.LATE7 = 0; } while(0)
#define RE7_Toggle()             do { LATEbits.LATE7 = ~LATEbits.LATE7; } while(0)
#define RE7_GetValue()           PORTEbits.RE7
#define RE7_SetDigitalInput()    do { TRISEbits.TRISE7 = 1; } while(0)
#define RE7_SetDigitalOutput()   do { TRISEbits.TRISE7 = 0; } while(0)

// get/set channel_AN8 aliases
#define channel_AN8_TRIS                 TRISFbits.TRISF3
#define channel_AN8_LAT                  LATFbits.LATF3
#define channel_AN8_PORT                 PORTFbits.RF3
#define channel_AN8_ANS                  anselRF3bits.anselRF3
#define channel_AN8_SetHigh()            do { LATFbits.LATF3 = 1; } while(0)
#define channel_AN8_SetLow()             do { LATFbits.LATF3 = 0; } while(0)
#define channel_AN8_Toggle()             do { LATFbits.LATF3 = ~LATFbits.LATF3; } while(0)
#define channel_AN8_GetValue()           PORTFbits.RF3
#define channel_AN8_SetDigitalInput()    do { TRISFbits.TRISF3 = 1; } while(0)
#define channel_AN8_SetDigitalOutput()   do { TRISFbits.TRISF3 = 0; } while(0)
#define channel_AN8_SetAnalogMode()      do { anselRF3bits.anselRF3 = 1; } while(0)
#define channel_AN8_SetDigitalMode()     do { anselRF3bits.anselRF3 = 0; } while(0)

// get/set channel_AN9 aliases
#define channel_AN9_TRIS                 TRISFbits.TRISF4
#define channel_AN9_LAT                  LATFbits.LATF4
#define channel_AN9_PORT                 PORTFbits.RF4
#define channel_AN9_ANS                  anselRF4bits.anselRF4
#define channel_AN9_SetHigh()            do { LATFbits.LATF4 = 1; } while(0)
#define channel_AN9_SetLow()             do { LATFbits.LATF4 = 0; } while(0)
#define channel_AN9_Toggle()             do { LATFbits.LATF4 = ~LATFbits.LATF4; } while(0)
#define channel_AN9_GetValue()           PORTFbits.RF4
#define channel_AN9_SetDigitalInput()    do { TRISFbits.TRISF4 = 1; } while(0)
#define channel_AN9_SetDigitalOutput()   do { TRISFbits.TRISF4 = 0; } while(0)
#define channel_AN9_SetAnalogMode()      do { anselRF4bits.anselRF4 = 1; } while(0)
#define channel_AN9_SetDigitalMode()     do { anselRF4bits.anselRF4 = 0; } while(0)

// get/set channel_AN10 aliases
#define channel_AN10_TRIS                 TRISFbits.TRISF5
#define channel_AN10_LAT                  LATFbits.LATF5
#define channel_AN10_PORT                 PORTFbits.RF5
#define channel_AN10_ANS                  anselRF5bits.anselRF5
#define channel_AN10_SetHigh()            do { LATFbits.LATF5 = 1; } while(0)
#define channel_AN10_SetLow()             do { LATFbits.LATF5 = 0; } while(0)
#define channel_AN10_Toggle()             do { LATFbits.LATF5 = ~LATFbits.LATF5; } while(0)
#define channel_AN10_GetValue()           PORTFbits.RF5
#define channel_AN10_SetDigitalInput()    do { TRISFbits.TRISF5 = 1; } while(0)
#define channel_AN10_SetDigitalOutput()   do { TRISFbits.TRISF5 = 0; } while(0)
#define channel_AN10_SetAnalogMode()      do { anselRF5bits.anselRF5 = 1; } while(0)
#define channel_AN10_SetDigitalMode()     do { anselRF5bits.anselRF5 = 0; } while(0)

// get/set channel_AN11 aliases
#define channel_AN11_TRIS                 TRISFbits.TRISF6
#define channel_AN11_LAT                  LATFbits.LATF6
#define channel_AN11_PORT                 PORTFbits.RF6
#define channel_AN11_ANS                  anselRF6bits.anselRF6
#define channel_AN11_SetHigh()            do { LATFbits.LATF6 = 1; } while(0)
#define channel_AN11_SetLow()             do { LATFbits.LATF6 = 0; } while(0)
#define channel_AN11_Toggle()             do { LATFbits.LATF6 = ~LATFbits.LATF6; } while(0)
#define channel_AN11_GetValue()           PORTFbits.RF6
#define channel_AN11_SetDigitalInput()    do { TRISFbits.TRISF6 = 1; } while(0)
#define channel_AN11_SetDigitalOutput()   do { TRISFbits.TRISF6 = 0; } while(0)
#define channel_AN11_SetAnalogMode()      do { anselRF6bits.anselRF6 = 1; } while(0)
#define channel_AN11_SetDigitalMode()     do { anselRF6bits.anselRF6 = 0; } while(0)

// get/set ADR_1 aliases
#define ADR_1_TRIS                 TRISGbits.TRISG0
#define ADR_1_LAT                  LATGbits.LATG0
#define ADR_1_PORT                 PORTGbits.RG0
#define ADR_1_SetHigh()            do { LATGbits.LATG0 = 1; } while(0)
#define ADR_1_SetLow()             do { LATGbits.LATG0 = 0; } while(0)
#define ADR_1_Toggle()             do { LATGbits.LATG0 = ~LATGbits.LATG0; } while(0)
#define ADR_1_GetValue()           PORTGbits.RG0
#define ADR_1_SetDigitalInput()    do { TRISGbits.TRISG0 = 1; } while(0)
#define ADR_1_SetDigitalOutput()   do { TRISGbits.TRISG0 = 0; } while(0)

// get/set ADR_2 aliases
#define ADR_2_TRIS                 TRISGbits.TRISG1
#define ADR_2_LAT                  LATGbits.LATG1
#define ADR_2_PORT                 PORTGbits.RG1
#define ADR_2_SetHigh()            do { LATGbits.LATG1 = 1; } while(0)
#define ADR_2_SetLow()             do { LATGbits.LATG1 = 0; } while(0)
#define ADR_2_Toggle()             do { LATGbits.LATG1 = ~LATGbits.LATG1; } while(0)
#define ADR_2_GetValue()           PORTGbits.RG1
#define ADR_2_SetDigitalInput()    do { TRISGbits.TRISG1 = 1; } while(0)
#define ADR_2_SetDigitalOutput()   do { TRISGbits.TRISG1 = 0; } while(0)

// get/set ADR_3 aliases
#define ADR_3_TRIS                 TRISGbits.TRISG2
#define ADR_3_LAT                  LATGbits.LATG2
#define ADR_3_PORT                 PORTGbits.RG2
#define ADR_3_SetHigh()            do { LATGbits.LATG2 = 1; } while(0)
#define ADR_3_SetLow()             do { LATGbits.LATG2 = 0; } while(0)
#define ADR_3_Toggle()             do { LATGbits.LATG2 = ~LATGbits.LATG2; } while(0)
#define ADR_3_GetValue()           PORTGbits.RG2
#define ADR_3_SetDigitalInput()    do { TRISGbits.TRISG2 = 1; } while(0)
#define ADR_3_SetDigitalOutput()   do { TRISGbits.TRISG2 = 0; } while(0)

// get/set ADR_4 aliases
#define ADR_4_TRIS                 TRISGbits.TRISG3
#define ADR_4_LAT                  LATGbits.LATG3
#define ADR_4_PORT                 PORTGbits.RG3
#define ADR_4_SetHigh()            do { LATGbits.LATG3 = 1; } while(0)
#define ADR_4_SetLow()             do { LATGbits.LATG3 = 0; } while(0)
#define ADR_4_Toggle()             do { LATGbits.LATG3 = ~LATGbits.LATG3; } while(0)
#define ADR_4_GetValue()           PORTGbits.RG3
#define ADR_4_SetDigitalInput()    do { TRISGbits.TRISG3 = 1; } while(0)
#define ADR_4_SetDigitalOutput()   do { TRISGbits.TRISG3 = 0; } while(0)

// get/set BAUD_1 aliases
#define BAUD_1_TRIS                 TRISGbits.TRISG4
#define BAUD_1_LAT                  LATGbits.LATG4
#define BAUD_1_PORT                 PORTGbits.RG4
#define BAUD_1_SetHigh()            do { LATGbits.LATG4 = 1; } while(0)
#define BAUD_1_SetLow()             do { LATGbits.LATG4 = 0; } while(0)
#define BAUD_1_Toggle()             do { LATGbits.LATG4 = ~LATGbits.LATG4; } while(0)
#define BAUD_1_GetValue()           PORTGbits.RG4
#define BAUD_1_SetDigitalInput()    do { TRISGbits.TRISG4 = 1; } while(0)
#define BAUD_1_SetDigitalOutput()   do { TRISGbits.TRISG4 = 0; } while(0)

// get/set BAUD_2 aliases
#define BAUD_2_TRIS                 TRISGbits.TRISG5
#define BAUD_2_LAT                  LATGbits.LATG5
#define BAUD_2_PORT                 PORTGbits.RG5
#define BAUD_2_SetHigh()            do { LATGbits.LATG5 = 1; } while(0)
#define BAUD_2_SetLow()             do { LATGbits.LATG5 = 0; } while(0)
#define BAUD_2_Toggle()             do { LATGbits.LATG5 = ~LATGbits.LATG5; } while(0)
#define BAUD_2_GetValue()           PORTGbits.RG5
#define BAUD_2_SetDigitalInput()    do { TRISGbits.TRISG5 = 1; } while(0)
#define BAUD_2_SetDigitalOutput()   do { TRISGbits.TRISG5 = 0; } while(0)

// get/set I2C_SPEED aliases
#define I2C_SPEED_TRIS                 TRISGbits.TRISG6
#define I2C_SPEED_LAT                  LATGbits.LATG6
#define I2C_SPEED_PORT                 PORTGbits.RG6
#define I2C_SPEED_SetHigh()            do { LATGbits.LATG6 = 1; } while(0)
#define I2C_SPEED_SetLow()             do { LATGbits.LATG6 = 0; } while(0)
#define I2C_SPEED_Toggle()             do { LATGbits.LATG6 = ~LATGbits.LATG6; } while(0)
#define I2C_SPEED_GetValue()           PORTGbits.RG6
#define I2C_SPEED_SetDigitalInput()    do { TRISGbits.TRISG6 = 1; } while(0)
#define I2C_SPEED_SetDigitalOutput()   do { TRISGbits.TRISG6 = 0; } while(0)

// get/set RG7 aliases
#define RG7_TRIS                 TRISGbits.TRISG7
#define RG7_LAT                  LATGbits.LATG7
#define RG7_PORT                 PORTGbits.RG7
#define RG7_SetHigh()            do { LATGbits.LATG7 = 1; } while(0)
#define RG7_SetLow()             do { LATGbits.LATG7 = 0; } while(0)
#define RG7_Toggle()             do { LATGbits.LATG7 = ~LATGbits.LATG7; } while(0)
#define RG7_GetValue()           PORTGbits.RG7
#define RG7_SetDigitalInput()    do { TRISGbits.TRISG7 = 1; } while(0)
#define RG7_SetDigitalOutput()   do { TRISGbits.TRISG7 = 0; } while(0)

// get/set channel_AN12 aliases
#define channel_AN12_TRIS                 TRISHbits.TRISH4
#define channel_AN12_LAT                  LATHbits.LATH4
#define channel_AN12_PORT                 PORTHbits.RH4
#define channel_AN12_ANS                  anselRH4bits.anselRH4
#define channel_AN12_SetHigh()            do { LATHbits.LATH4 = 1; } while(0)
#define channel_AN12_SetLow()             do { LATHbits.LATH4 = 0; } while(0)
#define channel_AN12_Toggle()             do { LATHbits.LATH4 = ~LATHbits.LATH4; } while(0)
#define channel_AN12_GetValue()           PORTHbits.RH4
#define channel_AN12_SetDigitalInput()    do { TRISHbits.TRISH4 = 1; } while(0)
#define channel_AN12_SetDigitalOutput()   do { TRISHbits.TRISH4 = 0; } while(0)
#define channel_AN12_SetAnalogMode()      do { anselRH4bits.anselRH4 = 1; } while(0)
#define channel_AN12_SetDigitalMode()     do { anselRH4bits.anselRH4 = 0; } while(0)

// get/set channel_AN13 aliases
#define channel_AN13_TRIS                 TRISHbits.TRISH5
#define channel_AN13_LAT                  LATHbits.LATH5
#define channel_AN13_PORT                 PORTHbits.RH5
#define channel_AN13_ANS                  anselRH5bits.anselRH5
#define channel_AN13_SetHigh()            do { LATHbits.LATH5 = 1; } while(0)
#define channel_AN13_SetLow()             do { LATHbits.LATH5 = 0; } while(0)
#define channel_AN13_Toggle()             do { LATHbits.LATH5 = ~LATHbits.LATH5; } while(0)
#define channel_AN13_GetValue()           PORTHbits.RH5
#define channel_AN13_SetDigitalInput()    do { TRISHbits.TRISH5 = 1; } while(0)
#define channel_AN13_SetDigitalOutput()   do { TRISHbits.TRISH5 = 0; } while(0)
#define channel_AN13_SetAnalogMode()      do { anselRH5bits.anselRH5 = 1; } while(0)
#define channel_AN13_SetDigitalMode()     do { anselRH5bits.anselRH5 = 0; } while(0)

// get/set channel_AN14 aliases
#define channel_AN14_TRIS                 TRISHbits.TRISH6
#define channel_AN14_LAT                  LATHbits.LATH6
#define channel_AN14_PORT                 PORTHbits.RH6
#define channel_AN14_ANS                  anselRH6bits.anselRH6
#define channel_AN14_SetHigh()            do { LATHbits.LATH6 = 1; } while(0)
#define channel_AN14_SetLow()             do { LATHbits.LATH6 = 0; } while(0)
#define channel_AN14_Toggle()             do { LATHbits.LATH6 = ~LATHbits.LATH6; } while(0)
#define channel_AN14_GetValue()           PORTHbits.RH6
#define channel_AN14_SetDigitalInput()    do { TRISHbits.TRISH6 = 1; } while(0)
#define channel_AN14_SetDigitalOutput()   do { TRISHbits.TRISH6 = 0; } while(0)
#define channel_AN14_SetAnalogMode()      do { anselRH6bits.anselRH6 = 1; } while(0)
#define channel_AN14_SetDigitalMode()     do { anselRH6bits.anselRH6 = 0; } while(0)

// get/set channel_AN15 aliases
#define channel_AN15_TRIS                 TRISHbits.TRISH7
#define channel_AN15_LAT                  LATHbits.LATH7
#define channel_AN15_PORT                 PORTHbits.RH7
#define channel_AN15_ANS                  anselRH7bits.anselRH7
#define channel_AN15_SetHigh()            do { LATHbits.LATH7 = 1; } while(0)
#define channel_AN15_SetLow()             do { LATHbits.LATH7 = 0; } while(0)
#define channel_AN15_Toggle()             do { LATHbits.LATH7 = ~LATHbits.LATH7; } while(0)
#define channel_AN15_GetValue()           PORTHbits.RH7
#define channel_AN15_SetDigitalInput()    do { TRISHbits.TRISH7 = 1; } while(0)
#define channel_AN15_SetDigitalOutput()   do { TRISHbits.TRISH7 = 0; } while(0)
#define channel_AN15_SetAnalogMode()      do { anselRH7bits.anselRH7 = 1; } while(0)
#define channel_AN15_SetDigitalMode()     do { anselRH7bits.anselRH7 = 0; } while(0)

// get/set RJ0 aliases
#define RJ0_TRIS                 TRISJbits.TRISJ0
#define RJ0_LAT                  LATJbits.LATJ0
#define RJ0_PORT                 PORTJbits.RJ0
#define RJ0_SetHigh()            do { LATJbits.LATJ0 = 1; } while(0)
#define RJ0_SetLow()             do { LATJbits.LATJ0 = 0; } while(0)
#define RJ0_Toggle()             do { LATJbits.LATJ0 = ~LATJbits.LATJ0; } while(0)
#define RJ0_GetValue()           PORTJbits.RJ0
#define RJ0_SetDigitalInput()    do { TRISJbits.TRISJ0 = 1; } while(0)
#define RJ0_SetDigitalOutput()   do { TRISJbits.TRISJ0 = 0; } while(0)

// get/set RJ1 aliases
#define RJ1_TRIS                 TRISJbits.TRISJ1
#define RJ1_LAT                  LATJbits.LATJ1
#define RJ1_PORT                 PORTJbits.RJ1
#define RJ1_SetHigh()            do { LATJbits.LATJ1 = 1; } while(0)
#define RJ1_SetLow()             do { LATJbits.LATJ1 = 0; } while(0)
#define RJ1_Toggle()             do { LATJbits.LATJ1 = ~LATJbits.LATJ1; } while(0)
#define RJ1_GetValue()           PORTJbits.RJ1
#define RJ1_SetDigitalInput()    do { TRISJbits.TRISJ1 = 1; } while(0)
#define RJ1_SetDigitalOutput()   do { TRISJbits.TRISJ1 = 0; } while(0)

// get/set RJ2 aliases
#define RJ2_TRIS                 TRISJbits.TRISJ2
#define RJ2_LAT                  LATJbits.LATJ2
#define RJ2_PORT                 PORTJbits.RJ2
#define RJ2_SetHigh()            do { LATJbits.LATJ2 = 1; } while(0)
#define RJ2_SetLow()             do { LATJbits.LATJ2 = 0; } while(0)
#define RJ2_Toggle()             do { LATJbits.LATJ2 = ~LATJbits.LATJ2; } while(0)
#define RJ2_GetValue()           PORTJbits.RJ2
#define RJ2_SetDigitalInput()    do { TRISJbits.TRISJ2 = 1; } while(0)
#define RJ2_SetDigitalOutput()   do { TRISJbits.TRISJ2 = 0; } while(0)

// get/set RJ3 aliases
#define RJ3_TRIS                 TRISJbits.TRISJ3
#define RJ3_LAT                  LATJbits.LATJ3
#define RJ3_PORT                 PORTJbits.RJ3
#define RJ3_SetHigh()            do { LATJbits.LATJ3 = 1; } while(0)
#define RJ3_SetLow()             do { LATJbits.LATJ3 = 0; } while(0)
#define RJ3_Toggle()             do { LATJbits.LATJ3 = ~LATJbits.LATJ3; } while(0)
#define RJ3_GetValue()           PORTJbits.RJ3
#define RJ3_SetDigitalInput()    do { TRISJbits.TRISJ3 = 1; } while(0)
#define RJ3_SetDigitalOutput()   do { TRISJbits.TRISJ3 = 0; } while(0)

// get/set RJ4 aliases
#define RJ4_TRIS                 TRISJbits.TRISJ4
#define RJ4_LAT                  LATJbits.LATJ4
#define RJ4_PORT                 PORTJbits.RJ4
#define RJ4_SetHigh()            do { LATJbits.LATJ4 = 1; } while(0)
#define RJ4_SetLow()             do { LATJbits.LATJ4 = 0; } while(0)
#define RJ4_Toggle()             do { LATJbits.LATJ4 = ~LATJbits.LATJ4; } while(0)
#define RJ4_GetValue()           PORTJbits.RJ4
#define RJ4_SetDigitalInput()    do { TRISJbits.TRISJ4 = 1; } while(0)
#define RJ4_SetDigitalOutput()   do { TRISJbits.TRISJ4 = 0; } while(0)

// get/set RJ5 aliases
#define RJ5_TRIS                 TRISJbits.TRISJ5
#define RJ5_LAT                  LATJbits.LATJ5
#define RJ5_PORT                 PORTJbits.RJ5
#define RJ5_SetHigh()            do { LATJbits.LATJ5 = 1; } while(0)
#define RJ5_SetLow()             do { LATJbits.LATJ5 = 0; } while(0)
#define RJ5_Toggle()             do { LATJbits.LATJ5 = ~LATJbits.LATJ5; } while(0)
#define RJ5_GetValue()           PORTJbits.RJ5
#define RJ5_SetDigitalInput()    do { TRISJbits.TRISJ5 = 1; } while(0)
#define RJ5_SetDigitalOutput()   do { TRISJbits.TRISJ5 = 0; } while(0)

// get/set RJ6 aliases
#define RJ6_TRIS                 TRISJbits.TRISJ6
#define RJ6_LAT                  LATJbits.LATJ6
#define RJ6_PORT                 PORTJbits.RJ6
#define RJ6_SetHigh()            do { LATJbits.LATJ6 = 1; } while(0)
#define RJ6_SetLow()             do { LATJbits.LATJ6 = 0; } while(0)
#define RJ6_Toggle()             do { LATJbits.LATJ6 = ~LATJbits.LATJ6; } while(0)
#define RJ6_GetValue()           PORTJbits.RJ6
#define RJ6_SetDigitalInput()    do { TRISJbits.TRISJ6 = 1; } while(0)
#define RJ6_SetDigitalOutput()   do { TRISJbits.TRISJ6 = 0; } while(0)

// get/set RJ7 aliases
#define RJ7_TRIS                 TRISJbits.TRISJ7
#define RJ7_LAT                  LATJbits.LATJ7
#define RJ7_PORT                 PORTJbits.RJ7
#define RJ7_SetHigh()            do { LATJbits.LATJ7 = 1; } while(0)
#define RJ7_SetLow()             do { LATJbits.LATJ7 = 0; } while(0)
#define RJ7_Toggle()             do { LATJbits.LATJ7 = ~LATJbits.LATJ7; } while(0)
#define RJ7_GetValue()           PORTJbits.RJ7
#define RJ7_SetDigitalInput()    do { TRISJbits.TRISJ7 = 1; } while(0)
#define RJ7_SetDigitalOutput()   do { TRISJbits.TRISJ7 = 0; } while(0)


/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/