/************************************************************************/
// Timer 1 fr PIC18F9J60
// Programmierer: Fa. Schwabenplan, Ingo Schick
// Compiler: XC8
// Datum: 29.02.2020
/************************************************************************/

#ifndef TMR1_H
#define TMR1_H

/************************************************************************/
// Include-Dateien
/************************************************************************/
#include <stdio.h>              
#include <string.h>			
#include <stdint.h>
#include <stdbool.h>

#include "TCPIPLibrary/device_config.h"
#include "DS1337.H"
#include "LM75.H"
#include "Display.H"
#include "eusart1.h"
/************************************************************************/

/************************************************************************/
// sonstige Definitionen
/************************************************************************/
#define TMR1_INTERRUPT_TICKER_FACTOR    1
/************************************************************************/

void TMR1_Initialize(void);
void TMR1_StartTimer(void);
void TMR1_StopTimer(void);
uint16_t TMR1_ReadTimer(void);
void TMR1_WriteTimer(uint16_t timerVal);
void TMR1_Reload(void);
void TMR1_ISR(void);
void TMR1_CallBack(void);
void TMR1_SetInterruptHandler(void (* InterruptHandler)(void));
extern void (*TMR1_InterruptHandler)(void);
void TMR1_DefaultInterruptHandler(void);

#endif // TMR1_H


